<?php
/***********************************************************
                http://www.DataFeedFile.com                    
------------------------------------------------------------    
  Script      : price_comparison.php
  Description : xml + php price comparison integration example
  Date        : 7/7/2006 -> updated 3/15/2009 (added CURL)
  Version     : 1.6
------------------------------------------------------------
  Note        : Demonstrate xml product price comparison
                parsing using xml2Array class (included at the bottom of this file) to generate
                price comparison page using PHP.
************************************************************/

/***********************************************************
 *  Setup your affiliate id , token and product id
 ***********************************************************/
$affid = 1001;

// this is our token id for affiliate # 1001 - (it may have changed) need to be changed to your own DFF Token.
// login to datafeedfile.com as affiliate - go to Settings > DFF Token > to generate your token id.
$dfftoken = 'YTA4ZDkyMDI2MTMyZWU4MWFhN2EwMT'; 

// PID is the same as DFF Product SKU - to find this number you can use our DFF Product SKU finder on our website
$pid = $_GET['pid'];
if($pid=='') $pid = 251109; // default product id / DFF Product SKU - you can specify your own product PID or SKU

/***********************************************************
 *  Getting Product Information & Price Comparison info
 ***********************************************************/

// This is the xml url service for product price comparison.
//  * Post affid, token and itemid together in querystring.
//  * See DOCTYPE in xml header to see the xml structure.


$xml_source = "http://www.datafeedfile.com/xml/xml_prdt_pricecomp.php?&dfftoken=$dfftoken&affid=$affid&product_sku=".$pid;

// GET XML DATA FEED FROM DATAFEEDFILE.COM SERVER
// THIS SCRIPT WILL DETECT TO CHECK IF CURL extension IS INSTALLED
// SOME HOSTING COMPANY DISABLE USING FOPEN AND FILE_GET_CONTENTS from Remote URL, so you must use CURL.

// CHECKING FOR CURL
if (function_exists('curl_init')) {
   // GET JSON ENCODED DATA USING CURL
   $ch = curl_init();
   curl_setopt($ch, CURLOPT_URL, $xml_source);
   //curl_setopt($ch, CURLOPT_POSTFIELDS, $request_string);       // <--- YOU CAN SPECIFY MORE POST VARIABLES HERE IF YOU NEED TO
   curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
   curl_setopt($ch, CURLOPT_USERAGENT, phpversion());
   $content = curl_exec($ch);
   curl_close($ch);
} else {
   // CURL DOES NOT EXISTS!
   // HOPEFULLY YOUR WEB SERVER ALLOW file_get_contents
   // GET JSON_ENCODED DATA USING file_get_contents
   $content = file_get_contents($xml_source);
}

/*
$content ='';
$pointer = fopen($xml_source, 'r');
while($data = fread($pointer, 2000))
  $content.=$data;
*/
  
// use xml2Array object to parse xml to array (xml2Array included at the bottom of this file)
$objXML = new xml2Array();

$arrOutput = $objXML->parse($content);

// Getting product info from <Summary> tag
$prdt_info= array();
if($arrOutput[0]['children'][1]['children'][0]['name'] == 'Summary'){
  $prdtinfo_arr = $arrOutput[0]['children'][1]['children'][0]['children'];
  
  // Getting all fields & their value in Summary tag
  if($prdtinfo_arr) {
  	foreach($prdtinfo_arr as $field){
    $prdt_info[$field['name']] = $field['tagData'];
  	}
  }


}

// Getting store prices from PriceComparison node
if($arrOutput[0]['children'][1]['children'][2]['name'] == 'PriceComparison'){
  // the xml response with product
  $merchant_arr = $arrOutput[0]['children'][1]['children'][2]['children'];
  foreach($merchant_arr  as $mer){
    foreach($mer['children'] as $merfield){
      if($merfield['tagData']!=''){
        $mer_prdt[$merfield['name']] = $merfield['tagData'];
      }
    }
    
    // Put sub child StoreRating.
    foreach($mer['children'][3]['children'] as $merfield){
      $mer_prdt['StoreRating'.$merfield['name']] = $merfield['tagData'];
    }
    foreach($mer['children'][4]['children'] as $merfield){
      $mer_prdt['Item'.$merfield['name']] = $merfield['tagData'];
    }
    $price_comparison[] = $mer_prdt;
  }
}


/************************************************************
 * Getting Similar Products
 *  This is the xml script that serve product search. 
 *  use this service to get related product within the same 
 *  category (catnum = 885). catnum is category number, 
 *  you can get the catnum values from our Category # Finder
 *  on the front page of DataFeedFile.com or inside the XML data
 *  uder Summary > Category nodes
 ***********************************************************/
$xml_source = "http://www.datafeedfile.com/xml/xml_search.php?affid=$affid&dfftoken=$dfftoken&catnum=885&limit=10";

// CHECKING FOR CURL
if (function_exists('curl_init')) {
   // GET JSON ENCODED DATA USING CURL
   $ch = curl_init();
   curl_setopt($ch, CURLOPT_URL, $xml_source);
   //curl_setopt($ch, CURLOPT_POSTFIELDS, $request_string);       // <--- YOU CAN SPECIFY MORE POST VARIABLES HERE IF YOU NEED TO
   curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
   curl_setopt($ch, CURLOPT_USERAGENT, phpversion());
   $content = curl_exec($ch);
   curl_close($ch);
} else {
   // CURL DOES NOT EXISTS!
   // HOPEFULLY YOUR WEB SERVER ALLOW file_get_contents
   // GET JSON_ENCODED DATA USING file_get_contents
   $content = file_get_contents($xml_source);
}

/*
$pointer = fopen($xml_source, 'r');
$content = '';
while($data = fread($pointer, 2000))
  $content.=$data ;
*/

$objXML = new xml2Array();
$arrOutput = $objXML->parse($content);

$similarprdt_arr = $arrOutput[0]['children'][1]['children']; 
foreach($similarprdt_arr as $sp){
  $temp_fields = array(); 
  foreach($sp['children'] as $field){
    $temp_fields[$field['name']] = $field['tagData'];
  } 
  $similarprdts[] = $temp_fields;
}



// Custom price comparison sort by selected column header.
if($price_comparison){
  // Re-Sort price_comarison array.
  $sort_order = $_GET['sd'];
  if(preg_match('/^(1|2|3)$/', $_GET['s'])){
    usort($price_comparison, 'usort_'. $_GET['s']);
  }
}

$sd1=$sd2=$sd3 = 'a';
$svar = 'sd'. $_GET['s'];
$$svar = ($sort_order=='a'?'d':'a');


/**
 * Custom Sorting Functions:
 */
function usort_1($left,$right){
  global $sort_order;
  ($left['StoreName']>$right['Name']?$ret = 1: $ret = -1);
  if($sort_order=='d') $ret*=-1;
  return $ret;   
}
function usort_2($left,$right){
  global $sort_order;
  ($left['StoreRatingAverage']>$right['StoreRatingAverage']?$ret = -1: $ret = 1);
  if($sort_order=='d') $ret*=-1;
  return $ret;   
}
function usort_3($left,$right){
  global $sort_order;
  ($left['ItemBasePrice']>$right['ItemBasePrice']?$ret = 1: $ret = -1);
  if($sort_order=='d') $ret*=-1;
  return $ret;   
}

function plural($val){
  if($val>1)return 's';
}



?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title><?=$prdt_info['Title'] . ' Price Comparison - DataFeedFile.com PHP+XML script integration example'?></title>
    <style type="text/css">

      #topbanner{
        background:url(thbg.gif) no-repeat;
        height:30px;
        text-align:left;
      }
      #topbanner h1{
        background:url(thbg_ne.gif) top right no-repeat;
        color:#FFF;
        font-family:Arial;
        font-size:16pt;
        padding:20px 20px 0px 20px;
        margin:0px;
        font-weight:normal;
      }
      .topbanner_content{
        background:url(thbg.gif) bottom left no-repeat;
        height:20px;
      }      
      .topbanner_content p{
        background:url(thbg_se.gif) bottom right no-repeat;
        height:20px;
      }  
      #content, td, th{
        font-family:Verdana, Helvetica, Arial;
        font-size:8pt;
        color:#777;
      }
      #content{
        width:500px;
        text-align:left;
      }
      a:link, a:visited{
        color:#00d;
      }
      a.store_label:link, a.store_label:visited{
        color:#777;
        text-decoration:none
      }
      a.store_label:hover{
        color:#F00;
      }
      .storelist th{
        font-weight:bold;
        background-color:#EEE;
      }
      .pic_frame{
        padding:5px;
        border:1px solid #DDDDDD;
      }
      h3{
        font-family:Arial;
        color:#F46D00;
        margin:0px 0px 10px 0px;
      }
      #prdt_info td{
        color:#666;
      }
      .thbg_left,.thbg_right,.thbg_mid{
        height:30px;
        text-align:center;
        color:#FFF;
      }
      .thbg_left a ,.thbg_right a,.thbg_mid a{
        font-family:Arial;
        font-size:10pt;
        font-weight:bold;
      }
      .bold_note{
        color:#999;
        font-weight:bold;
      }
      .thbg_left a:link,.thbg_right a:link,.thbg_mid a:link,
      .thbg_left a:visited,.thbg_right a:visited,.thbg_mid a:visited
      {
        color:#FFF;
        text-decoration:none        
      }    
      .thbg_left{
        background:url(thbg.gif) no-repeat;
      }
      .thbg_mid{
        border-left:1px solid #FFF;
        background:url(thbg_mid.gif);
      }
      .thbg_right{
        border-left:1px solid #FFF;
        background:url(thbg.gif) top right no-repeat;
      }

      .td_cell, .td_cell_left, .td_cell_right{
        border-bottom:1px solid #DDDDDD;
      }
      
      .td_cell_left, .td_cell, .td_cell_right, .td_cell_right_bottom{
        border-left:1px solid #DDDDDD;
      }
      .td_cell_right{
        border-right:1px solid #DDDDDD;
      }

      .td_cell_left_bottom{
        background:url(tdbottom.gif) bottom left no-repeat;
      }
      .td_cell_right_bottom{
        background:url(tdbottom.gif) bottom right no-repeat;
      }
      #sidebar{
        float:right;
        width:200px;
        background-color:#EEE;
      }
    </style>
  </head>


  <body>


    <center>
    <div id="topbanner">
      <h1><?=$prdt_info['Title']?></h1>
      <div class="topbanner_content"><p>&nbsp;</p></div>
    </div>
    <table style="margin-top:60px;">
      <tr>
      <td id="content" valign="top">

	    <table id="prdt_info">
	        <tr>
	          <td valign="top">
	          <?if($prdt_info){
	          	if($prdt_info['Thumbnail']['URL']==''){
	          		$prdt_info['Thumbnail']['URL'] = 'http://df9.us/c?c='.$prdt_info['SKU'];
	         	}
	          ?>
	          
	            <img src="<?=$prdt_info['Thumbnail']['URL']?>" align="left" style="margin:6px" alt="<?=$prdt_info['Description']?>">
	            <span class="bold_note">Description:</span><br>
	            <?=$prdt_info['LongDescription']?>
	          <?}else{
	            echo "Product information not available";
	          }?>
	          </td>
	        </tr>
	    </table>
    
<?if($price_comparison){?>    
    <span class="bold_note">Buying Information from <?=$prdt_info['MerchantCount']?> store<?=plural($prdt_info['MerchantCount']);?></span><br>
    <br><table class="storelist" border="0" cellspacing="0" width="100%">
      <tr>
        <th class="thbg_left" align="center"><a href="<?=str_replace("&","&amp;", $_SERVER['PHP_SELF']. '?pid='.$_GET['pid'].'&s=1&sd='.$sd1);?>">Store</a></th>
        <th class="thbg_mid"><a href="<?=str_replace("&","&amp;",$_SERVER['PHP_SELF']. '?pid='.$_GET['pid'].'&s=2&sd='.$sd2);?>">Store Rating</a></th>
        <th class="thbg_right"><a href="<?=str_replace("&","&amp;",$_SERVER['PHP_SELF']. '?pid='.$_GET['pid'].'&s=3&sd='.$sd3);?>">Price</a></th>
      </tr>
<?
$row = 0;
// Generate store pricing rows
foreach($price_comparison as $pc){
    
  $row++;
  // assign appropriate class for each cell
  if($row == sizeof($price_comparison)){
    $cell_left_class  = 'td_cell_left_bottom';
    $cell_right_class  = 'td_cell_right_bottom';
    $cell_mid_class  = 'td_cell';
  }else{
    $cell_left_class  = 'td_cell_left';
    $cell_right_class  = 'td_cell_right';
    $cell_mid_class  = 'td_cell';
  }
  
  echo 
  '<tr>
    <td align="center" class="'. $cell_left_class .'"><a href="'.str_replace("&","&amp;", $pc['ItemURL']).'" ><img src="'. $pc['Logo'].'" border="0" alt=""></a><br><a href="'. str_replace("&","&amp;", $pc['ItemURL']).'" class="store_label">'.trim($pc['Name']).'</a>
    </td>
    <td align="center" class="td_cell">'.$pc['StoreRatingAverage']. '</td>
    <td align="center" class="'. $cell_right_class .'"><b><a href="'.str_replace("&","&amp;", $pc['ItemURL']).'">$'. number_format($pc['ItemBasePrice'],2).'</a></b></td>
  </tr>';
       
}?>      
    </table><br>
    Price list powered by <a href="http://www.DataFeedFile.com">DataFeedFile.com</a>
<?}?>    
        </td>
        <td width="200" valign="top">
          <span class="bold_note">Related Products</span>
          <p>
          <?
          
          //print_r($similarprdts);
          
          echo '<ul>';
          foreach($similarprdts as $prdt){
            echo '<li><a href="?pid='. $prdt['product_sku'] .'"><img width="80" height="80" src="http://df9.us/c?c='.$prdt['product_sku'].'" border="0"><br>'. $prdt['title'] .'</a></li>';
          }
          echo '</ul>';
          
          
          ?>
          
          
        </td>
      </tr>
    </table>
    </center>
  </body>


</html><?

class xml2Array {
  
  /**
   *   This class object grabbed from php.net.
   *
   */
   
   var $arrOutput = array();
   var $resParser;
   var $strXmlData;
   
   function parse($strInputXML) {
          
           //echo $strInputXML;exit;
           global $content;
          
           $this->resParser = xml_parser_create ();
           xml_parser_set_option($this->resParser,XML_OPTION_CASE_FOLDING, false); 
           xml_set_object($this->resParser,$this);
           xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");
           
           xml_set_character_data_handler($this->resParser, "tagData");
       
           $this->strXmlData = xml_parse($this->resParser,$strInputXML );
           if(!$this->strXmlData) {
               die(sprintf("XML error: %s at line: %d<br>Error code: %d<br><br>%s",
           xml_error_string(xml_get_error_code($this->resParser)),
           xml_get_current_line_number($this->resParser), xml_get_error_code ( $this->resParser ), $content));
           }
                           
           xml_parser_free($this->resParser);
           
           return $this->arrOutput;
   }
   function tagOpen($parser, $name, $attrs) {
       $tag=array("name"=>$name,"attrs"=>$attrs); 
       array_push($this->arrOutput,$tag);
   }
   
   function tagData($parser, $tagData) {
       if(trim($tagData)) {
           if(isset($this->arrOutput[count($this->arrOutput)-1]['tagData'])) {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] .= $tagData;
           } 
           else {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] = $tagData;
           }
       }
   }
   
   function tagClosed($parser, $name) {
       $this->arrOutput[count($this->arrOutput)-2]['children'][] = $this->arrOutput[count($this->arrOutput)-1];
       array_pop($this->arrOutput);
   }
}

?>